'''Dungeons and Dragons Mod for Source
Mod Based of Dungeons and Dragons 4.0 System (Pen and Paper)
Preview Info: http://dnd4.com/phb
By: J3ff Hoogland
First Version found @ http://addons.eventscripts.com/addons/view/dnd (Based on 3.5)'''
import es, popuplib, random, gamethread, cPickle, os.path, math, langlib, playerlib, gc, effectlib
info = es.AddonInfo()
info.name = 'Dungeons and Dragons: Source'
info.version = '0.1.8 Python'
info.url = 'http://addons.eventscripts.com/addons/view/dnds'
info.basename = 'dnds'
info.author = 'J3ff Hoogland'
es.ServerVar('DnD',info.version,'Dungeons and Dragons By: J3ff Hoogland').makepublic()
#Debug Blocks
def report(message):
    if int(es.ServerVar('dnds_Debug')):
        if int(es.ServerVar('dnds_Debug')) == 1:
            es.dbgmsg(0, '[Dungeons and Dragons] Debug - %s'%message)
        else:
            es.msg('#multi', '#green[Dungeons and Dragons] Debug - #default%s'%message)
        a = open(es.getAddonPath('dnds') + '/debug.txt','a')
        a.writelines('\n %s' % message)
        es.msg(message)
        a.close()
#Being Events
#Begin Player Events
def player_connect(ev):
    report('%s connected'%ev['name'])
def player_disconnect(ev):
    userid = int(ev['userid'])
    delPlayer(userid)
def player_spawn(ev):
    report('%s spawned'%ev['es_username'])
    userid = int(ev['userid'])
    if not es.isbot(userid):
        getPlayer(userid)['Player'].CheckCharacter()
        if not len(getPlayer(userid)['Character'].key['classes']):
            getPlayer(userid)['Menu'].ClassMenu()
            if int(ev['es_userteam']) > 1:
                es.changeteam(userid, 1)
            es.tell(userid, '#multi', text('player_spawn 1',{},getPlayer(userid)['playerlib'].get('lang')))
        elif 'Ranger' in getPlayer(userid)['Character'].key['classes'] and not getPlayer(userid)['Character'].key['weapon type']:
            getPlayer(userid)['Menu'].RangerType()
        elif not statCheck(userid):
            getPlayer(userid)['Menu'].StatManual()
            if int(ev['es_userteam']) > 1:
                es.changeteam(userid, 1)
            es.tell(userid, '#multi', text('player_spawn 2',{},getPlayer(userid)['playerlib'].get('lang')))
        elif getPlayer(userid)['Character'].key['race'] == 'Pending':
            getPlayer(userid)['Menu'].RaceMenu()
            if int(ev['es_userteam']) > 1:
                es.changeteam(userid, 1)
            es.tell(userid, '#multi', text('player_spawn 3',{},getPlayer(userid)['playerlib'].get('lang')))
        elif getPlayer(userid)['Character'].key['paragon path'] == 'pending':
            getPlayer(userid)['Menu'].ParagonMenu()
        elif len(getPlayer(userid)['Character'].key['stat increase']):
            getPlayer(userid)['Menu'].IncreaseStat()
        elif 'unspent' in getPlayer(userid)['Character'].key['feats']:
            getPlayer(userid)['Menu'].FeatMenu()
        elif getPlayer(userid)['Character'].key['paragon path'] == 'pending':
            getPlayer(userid)['Menu'].ParagonMenu()
        elif getPlayer(userid)['Character'].key['paragon path'] == 'multi class' and len(getPlayer(userid)['Character'].key['classes']) == 1:
            getPlayer(userid)['Menu'].MultiMenu()
def player_jump(ev):
    userid = int(ev['userid'])
    jump_multiplier = getPlayer(userid)['Player'].key['long jump']
    temp_multiplier = jump_multiplier - 1
    es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s' % tuple([es.getplayerprop(userid, 'CBasePlayer.localdata.m_vecVelocity[%s]' % x) * temp_multiplier for x in range(3)]))
def player_death(ev):
    global Players
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    if ev['es_attackerteam'] != ev['es_userteam'] and attacker:
        getPlayer(attacker)['Character'].GiveXp(int(es.ServerVar('dnds_KillXp')), text('player_death 1',{'es_username':ev['es_username']},getPlayer(attacker)['playerlib'].get('lang')))
    for d in Players[userid]['delay list']:
        gamethread.cancelDelayed(d)
    Players[userid]['delay list'] = []
def player_hurt(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    if gamedir != 'cstrike' and gamedir != 'dod':
        es.event('initialize', 'player_damage')
        es.event('setint','player_damage','userid',userid)
        es.event('setint','player_damage','dmg_health',getPlayer(userid)['Player'].key['health']-int(es.getplayerprop(userid,'CBasePlayer.m_iHealth')))
        es.event('setint','player_damage','attacker',attacker)
        if attacker:
            es.event('setstring','player_damage','weapon',getPlayer(attacker)['playerlib'].get('weapon'))
        else:
            es.event('setstring','player_damage','weapon','world')
        es.event('setint','player_damage','health',int(es.getplayerprop(userid,'CBasePlayer.m_iHealth')))
        es.event('fire','player_damage')
#End Player Events
#Begin global events
def es_map_start(ev):
    es.loadevents('declare', 'addons/eventscripts/dnds/events.res')
def round_end(ev):
    global Players
    winner = int(ev['winner'])
    for d in Players['delay list']:
        gamethread.cancelDelayed(d)
    Players['delay list'] = []
    for id in Players:
        if id != 'delay list':
            for d in Players[id]['delay list']:
                gamethread.cancelDelayed(d)
            Players[id]['delay list'] = []
#End global events
#End Events
#Begin Looping Methods
#Our looping method that handel things such as saving and messaging that the mod is running
def LoopBlock():
    for userid in es.getUseridList():
        es.tell(userid, '#multi', text('LoopBlock 1',{},getPlayer(userid)['playerlib'].get('lang')))
    str_path = open(es.getAddonPath('dnds') + '/Characters.db', 'w')
    cPickle.dump(Characters, str_path)
    str_path.close()
    gamethread.delayedname(30, 'dnds loop', LoopBlock)
#Looping block that keep's all user's gravity at the correct amount
def Check():
    for userid in es.getUseridList():
        es.server.queuecmd('es_xfire %s %s %s %s'%(userid, '!self', 'addoutput', '"gravity %s"'%getPlayer(userid)['Player'].key['gravity']))
        getPlayer(userid)['Player'].CheckCharacter()
    gamethread.delayedname(0.5, 'dnds check', Check)
#Loops everytime the server tics (used to player_damage for none CSS/dods games)
def Ticker():
    for id in es.getUseridList():
        getPlayer(id)['Player'].key['health'] = int(es.getplayerprop(id,'CBasePlayer.m_iHealth'))
#End looping methods
#Begin Load Method (And commands)
Players = {'delay list':[]}
Races = {'Dragonborn':{'info':['Dragonborn 1']},
    'Dwarf':{'info':['Dwarf 1']},
    'Eladrin':{'info':['Eladrin 1']},
    'Elf':{'info':['Elf 1']},
    'Half Elf':{'info':['Half Elf 1']},
    'Halfling':{'info':['Halfling 1']},
    'Human':{'info':['Human 1','Human 2']},
    'Tiefling':{'info':['Tiefling 1']}}
Race_List = ['Dragonborn','Dwarf','Eladrin','Elf','Half Elf','Halfling','Human','Tiefling']
Classes = {'Cleric':{'info':[],
                    'powers1':[],
                    'powers2':[],
                    'powers3':[],
                    'powers4':[],
                    'paragon paths':{'Angelic Avenger':[],
                                    'Radiant Servant':[],
                                    'Warpriest':[]}},
    'Fighter':{     'info':[],
                    'powers1':[],
                    'powers2':[],
                    'powers3':[],
                    'powers4':[],
                    'paragon paths':{'Iron Master':[],
                                    'Kensi':[],
                                    'Pit Fighter':[]}},
    'Paladin':{     'info':[],
                    'powers1':[],
                    'powers2':[],
                    'powers3':[],
                    'powers4':[],
                    'paragon paths':{'Astral Weapon':[],
                                    'Champion of Order':[],
                                    'Hospitaler':[]}},
    'Ranger':{      'info':[],
                    'powers1':[],
                    'powers2':[],
                    'powers3':[],
                    'powers4':[],
                    'paragon paths':{'Battlefield Archer':[],
                                    'Pathfinder':[],
                                    'Stormwarden':[]}},
    'Rogue':{       'info':[],
                    'powers1':[],
                    'powers2':[],
                    'powers3':[],
                    'powers4':[],
                    'paragon paths':{'Daggermaster':[],
                                    'Master Infiltrator':[],
                                    'Shadow Assassin':[]}},
    'Warlock':{     'info':[],
                    'powers1':[],
                    'powers2':[],
                    'powers3':[],
                    'powers4':[],
                    'paragon paths':{'Doomsayer':[],
                                    'Feytouched':[],
                                    'Life-Stealer':[]}},
    'Warlord':{     'info':[],
                    'powers1':[],
                    'powers2':[],
                    'powers3':[],
                    'powers4':[],
                    'paragon paths':{'Battle Captain':[],
                                    'Knight Veteran':[],
                                    'Sword Marshal':[]}},
    'Wizard':{      'info':[],
                    'powers1':[],
                    'powers2':[],
                    'powers3':[],
                    'powers4':[],
                    'paragon paths':{'Battle Mage':[],
                                    'Blood Mage':[],
                                    'Spellstorm Mage':[]}}}
Class_List = ['Cleric','Fighter','Paladin','Ranger','Rogue','Warlock','Warlord','Wizard']
Abilities = {'Strength':{'info':[]},
    'Constitution':{'info':['Constitution 1','Constitution 2']},
    'Dexterity':{'info':['Dexterity 1']},
    'Intelligence':{'info':['Intelligence 1']},
    'Wisdom':{'info':[]},
    'Charisma':{'info':[]}}
Ability_List = ['Strength','Constitution','Dexterity','Intelligence','Wisdom','Charisma']
Ability_Increases = [4, 8, 12, 16, 20, 24, 28]
Feats = {'Backstabber':{'info':['Backstabber 1','Backstabber 2'],
                    'requirements':{'abilities':{}, 'classes':{'Rogue':1}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Dwarven Weapon Training':{'info':['Dwarven Weapon Training 1'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':['Dwarf'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Durable':{'info':['Durable 1'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Eladrin Soldier':{'info':['Eladrin Soldier 1'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':['Eladrin'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Fast Runner':{'info':['Fast Runner 1','Fast Runner 2'],
                    'requirements':{'abilities':{'Constitution':13}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Healing Hands':{'info':['Healing Hands 1','Healing Hands 2'],
                    'requirements':{'abilities':{}, 'classes':{'Paladin':2}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Light Step':{'info':['Light Step 1','Light Step 2'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':['Elf','Half Elf'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Long Jumper':{'info':['Long Jumper 1'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Power Attack':{'info':['Power Attack 1'],
                    'requirements':{'abilities':{'Strength':15}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Toughness':{'info':['Toughness 1'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Alertness':{'info':['Alertness 1'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Dodge Giants':{'info':['Dodge Giants 1','Dodge Giants 2'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':['Dwarf'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Expand Spellbook':{'info':['Expand Spellbook 1','Expand Spellbook 2'],
                    'requirements':{'abilities':{}, 'classes':{'Wizard':1}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Group Insight':{'info':['Group Insight 1','Group Insight 2'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':['Half Elf'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Hellfire Blood':{'info':['Hellfire Blood 1','Hellfire Blood 2'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':['Tiefling'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Improved Initiative':{'info':['Improved Initiative 1'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Lost in the Crowd':{'info':['Lost in the Crowd 1','Lost in the Crowd 2'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':['Halfling'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Press the Advantage':{'info':['Press the Advantage 1'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Weapon Focus':{'info':['Weapon Focus 1'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Initiate of the Faith':{'info':['Initiate of the Faith 1','Initiate of the Faith 2'],
                    'requirements':{'abilities':{'Wisdom':13}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':['Cleric','Warlord']}},
        'Sneak of Shadows':{'info':['Sneak of Shadows 1','Sneak of Shadows 2'],
                    'requirements':{'abilities':{'Dexterity':13}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':['Rogue']}},
        'Pact Initiate':{'info':['Pact Initiate 1','Pact Initiate 2'],
                    'requirements':{'abilities':{'Charisma':13}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':['Warlock']}},
        'Stead Fast':{'info':['Stead Fast 1'],
                    'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},}
Feat_List = ['Alertness',
            'Backstabber',
            'Dwarven Weapon Training',
            'Dodge Giants',
            'Durable',
            'Eladrin Soldier',
            'Expand Spellbook',
            'Fast Runner',
            'Group Insight',
            'Healing Hands',
            'Hellfire Blood',
            'Initiate of the Faith',
            'Improved Initiative',
            'Light Step',
            'Long Jumper',
            'Lost in the Crowd',
            'Pact Initiate',
            'Power Attack',
            'Press the Advantage',
            'Sneak of Shadows',
            'Stead Fast',
            'Toughness',
            'Weapon Focus']
Feat_Increases = [2, 4, 6, 8, 10, 11, 12, 14, 16, 18, 20, 21, 22, 24, 26, 28, 30]
Characters = {}
Public_Characters = []
#                     Level : Xp Needed to Obtain it
Levels = {2:1000,
    3:2250,
    4:3750,
    5:5500,
    6:7500,
    7:10000,
    8:13000,
    9:16500,
    10:20500,
    11:25500,
    12:31500,
    13:38500,
    14:46500,
    15:56500,
    16:68500,
    17:82500,
    18:98500,
    19:118500,
    20:142500,
    21:170500,
    22:202500,
    23:244000,
    24:295000,
    25:355500,
    26:425500,
    27:515500,
    28:625500,
    29:755500,
    30:905500}
def load():
    es.dbgmsg(0, '[Dungeons and Dragons] - Begin Load')
    global text, Characters, gamedir, game
    text = langlib.Strings(es.getAddonPath('dnds') + '/strings.ini')
    str_path = es.getAddonPath('dnds') + '/Characters.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        Characters = cPickle.load(file_users)
        file_users.close()
        for c in Characters:
            if Characters[c]['password'] == 'public':
                Public_Characters.append(c)
    gamedir = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').split('/')[~0]
    if gamedir in ['cstrike','hl2mp','dod','pvkii','tf']:
        es.load('dnds/games/%sdnds'%gamedir)
    gamevar = None
    if gamedir == 'cstrike':
        game = 'Counter-Strike: Source'
        '''import cstrikednds
        from cstrikednds import cstrikednds
        gamevar = cstrikednds'''
    elif gamedir == 'hl2mp':
        game = 'Half Life 2 Deathmatch'
        '''import hl2mpdnds
        from hl2mpdnds import hl2mpdnds
        gamevar = hl2mpdnds'''
    elif gamedir == 'dod':
        game = 'Day of Defeat: Source'
        '''import doddnds
        from doddnds import doddnds
        gamevar = doddnds'''
    elif gamedir == 'pvkii':
        game = 'Pirates, Vikings, and Knights'
        '''import pvkiidnds
        from pvkiidnds import pvkiidnds
        gamevar = pvkiidnds'''
    elif gamedir == 'tf':
        game = 'Team Fortress 2'
        '''import tfdnds
        from tfdnds import tfdnds
        gamevar = tfdnds'''
    else:
        game = 'Unknown'
        es.dbgmsg(0, '[Dungeons and Dragons] - Game is Unkown - Request support for this game @ http://featurelist.org/dnds')
    es.dbgmsg(0, '[Dungeons and Dragons] - Directory %s'%gamedir)
    es.dbgmsg(0, '[Dungeons and Dragons] - Game %s'%game)
    if not es.exists('saycommand', 'dnd'):
        es.regsaycmd('dnd', 'dnds/Command')
    if not es.exists('clientcommand', 'dnd'):
        es.regclientcmd('dnd', 'dnds/Command')
    ServerVars = {'dnds_KillXp':65,
                    'dnds_Debug':0}
    for x in ServerVars:
        es.ServerVar(x).set(ServerVars[x])
    if os.path.isfile(es.getAddonPath('dnds')+'/dnds.cfg'):
        es.server.queuecmd('es_xmexec ../addons/eventscripts/dnds/dnds.cfg')
    else:
        es.dbgmsg(0, '[Dungeons and Dragons] - Cannot find the dnds.cfg file! - Using default values...')
    LoopBlock()
    Check()
    DemoCharacters()
    es.loadevents('declare', 'addons/eventscripts/dnds/events.res')
    if gamedir != 'cstrike' and gamedir != 'dod':
        es.addons.registerTickListener(Ticker)
    es.dbgmsg(0, '[Dungeons and Dragons] - Load Finished')
#builds our demo characters, added into it's own method to allow backwards support for Version < 0.1.7 and for customization
def DemoCharacters():
    Characters['Cleric'] = {'creator':'J3ff Hoogland',
                            'race':'Elf',
                            'classes':{'Cleric':{'level':5}},
                            'feats':['Alertness','Light Step','Fast Runner'],
                            'abilities':{'Strength':14,
                                        'Constitution':12,
                                        'Dexterity':14,
                                        'Intelligence':10,
                                        'Wisdom':18,
                                        'Charisma':14},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Fighter'] = {'creator':'J3ff Hoogland',
                            'race':'Dwarf',
                            'classes':{'Fighter':{'level':5}},
                            'feats':['Dwarven Weapon Training','Improved Initiative','Toughness'],
                            'abilities':{'Strength':14,
                                        'Constitution':18,
                                        'Dexterity':14,
                                        'Intelligence':10,
                                        'Wisdom':14,
                                        'Charisma':12},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Paladin'] = {'creator':'J3ff Hoogland',
                            'race':'Half Elf',
                            'classes':{'Paladin':{'level':5}},
                            'feats':['Durable','Healing Hands','Group Insight'],
                            'abilities':{'Strength':16,
                                        'Constitution':16,
                                        'Dexterity':12,
                                        'Intelligence':10,
                                        'Wisdom':12,
                                        'Charisma':16},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Ranger'] = {'creator':'J3ff Hoogland',
                            'race':'Halfling',
                            'classes':{'Ranger':{'level':5}},
                            'feats':['Press the Advantage','Fast Runner','Lost in the Crowd'],
                            'abilities':{'Strength':14,
                                        'Constitution':12,
                                        'Dexterity':18,
                                        'Intelligence':12,
                                        'Wisdom':14,
                                        'Charisma':12},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':'archer',
                            'paragon path':None}
    Characters['Rogue'] = {'creator':'J3ff Hoogland',
                            'race':'Human',
                            'classes':{'Rogue':{'level':5}},
                            'feats':['Improved Initiative','Backstabber','Long Jumper','Fast Runner'],
                            'abilities':{'Strength':12,
                                        'Constitution':14,
                                        'Dexterity':18,
                                        'Intelligence':14,
                                        'Wisdom':12,
                                        'Charisma':10},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Warlock'] = {'creator':'J3ff Hoogland',
                            'race':'Tiefling',
                            'classes':{'Warlock':{'level':5}},
                            'feats':['Hellfire Blood','Durable','Fast Runner'],
                            'abilities':{'Strength':12,
                                        'Constitution':14,
                                        'Dexterity':12,
                                        'Intelligence':16,
                                        'Wisdom':10,
                                        'Charisma':18},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Warlord'] = {'creator':'J3ff Hoogland',
                            'race':'Dragonborn',
                            'classes':{'Warlord':{'level':5}},
                            'feats':['Power Attack','Durable','Toughness'],
                            'abilities':{'Strength':18,
                                        'Constitution':12,
                                        'Dexterity':12,
                                        'Intelligence':14,
                                        'Wisdom':10,
                                        'Charisma':16},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Wizard'] = {'creator':'J3ff Hoogland',
                            'race':'Eladrin',
                            'classes':{'Wizard':{'level':5}},
                            'feats':['Expand Spellbook','Alertness','Toughness'],
                            'abilities':{'Strength':10,
                                        'Constitution':14,
                                        'Dexterity':16,
                                        'Intelligence':18,
                                        'Wisdom':12,
                                        'Charisma':12},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
#End Load Methods
#Begin unload methods
def unload():
    es.dbgmsg(0, '[Dungeons and Dragons] - Unload Start')
    for id in es.getUseridList():
        getPlayer(id)['Menu'].Unsend()
    if gamedir != 'cstrike' and gamedir != 'dod':
        es.addons.unregisterTickListener(Ticker)
    for d in Players['delay list']:
        gamethread.cancelDelayed(d)
    for id in Players:
        if id != 'delay list':
            for d in Players[id]['delay list']:
                gamethread.cancelDelayed(d)
    for d in ['dnds loop', 'dnds check']:
        gamethread.cancelDelayed(d)
    str_path = open(es.getAddonPath('dnds') + '/Characters.db', 'w')
    cPickle.dump(Characters, str_path)
    str_path.close()
    es.unload('dnds/games/%sdnds'%gamedir)
    es.dbgmsg(0, '[Dungeons and Dragons] - Unload End')
#end unload methods
#Begin global methods
def defaultBot(userid):
    Players[self.userid] = {}
    Players[self.userid]['character'] = None
    Players[self.userid]['pending'] = None
    Players[self.userid]['characters list'] = []
    Players[self.userid]['delay list'] = []
    Players[self.userid]['gravity'] = 1.0
    Players[self.userid]['long jump'] = 1.0
#My range() function beacuse the built in one does not work how I like
def range(start=0, stop=0, step=1):
    if not stop:
        stop = start
        start = 0
    mylist = []
    while start < stop:
        mylist.append(start)
        start += step
    return mylist
'''My Range Method:
    for i in range(.5, 8, .5): print i

    0.5
    1.0
    1.5
    2.0
    2.5
    3.0
    3.5
    4.0
    4.5
    5.0
    5.5
    6.0
    6.5
    7.0
    7.5

    Built in:
    for i in range(.5, 8, .5): print i


    Warning (from warnings module):
      File "__main__", line 1
    DeprecationWarning: integer argument expected, got float

    Traceback (most recent call last):
      File "<pyshell#1>", line 1, in <module>
        for i in range(.5, 8, .5): print i
    ValueError: range() step argument must not be zero'''
#Blind a user
def Blind(userid, delay, alpha=255):
    es.server.queuecmd('est_Fade %s 1 0 %s 0 0 0 %s'%(userid, delay, alpha))
#A few simple effects
def Beam(player1,player2,life,r,g,b):
    #Sends a random beam connecting the two players with the given RGB color values
    choice = random.randint(1, 2)
    if choice == 1:
        Beam1(player1,player2,life,r,g,b)
    #Didnt like how this beam looks
    #elif choice == 2:
    #    Beam2(player1,player2,life,r,g,b)
    elif choice == 2:
        Beam3(player1,player2,life,r,g,b)
def Beam1(player1,player2,life,r,g,b):
    # Connects 2 users together via a normal beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    if gamedir != 'pvkii' and game != 'Unknown':
        es.server.queuecmd('est_effect 3 #a 0 sprites/lgtning.vmt %s %s %s %s %s %s %s 40 10 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
    else:
        effectlib.drawLine((x,y,z+30), (x1,y1,z1+30), model="sprites/lgtning.vmt", seconds=life, red=r, green=g, blue=b)
def Beam2(player1,player2,life,r,g,b):
    # Connects 2 users together via a more rough beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    if gamedir != 'pvkii' and game != 'Unknown':
        es.server.queuecmd('est_effect 3 #a 0 effects/tp_eyefx/tpeye3.vmt %s %s %s %s %s %s %s 7 3 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
    else:
        effectlib.drawLine((x,y,z+30), (x1,y1,z1+30), model="effects/tp_eyefx/tpeye3.vmt", seconds=life, red=r, green=g, blue=b)
def Beam3(player1,player2,life,r,g,b):
    # Connects 2 users together via a laser beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    if gamedir != 'pvkii' and game != 'Unknown':
        es.server.queuecmd('est_effect 3 #a 0 materials/sprites/laser.vmt %s %s %s %s %s %s %s 40 10 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
    else:
        effectlib.drawLine((x,y,z+30), (x1,y1,z1+30), model="materials/sprites/laser.vmt", seconds=life, red=r, green=g, blue=b)
#Returns the ability mod of a given score value
def statMod(userid, stat):
    if getPlayer(userid)['Character'].key['abilities'][stat]:
        return (getPlayer(userid)['Character'].key['abilities'][stat]-10)/2
    return 0
#Checks to see if any of a user's ability scores are 0
def statCheck(userid):
    abilities = getPlayer(userid)['Character'].key['abilities']
    for a in Ability_List:
        if not abilities[a]:
            return None
            break
    return 1
#Used to handle all acessing of classes (Menu, Character, and Player)
__Players = {}
def getPlayer(userid):
    #report('%s is running through the getPlayer block'%es.getplayername(userid))
    userid = int(userid)
    if es.exists('userid', userid):
        global __Players
        if userid not in __Players:
            report('Creating a user key for %s for the 3 global classes'%es.getplayername(userid))
            __Players[userid] = {'Player':Player(userid),'Menu':Menu(userid),'Character':Character(userid),'playerlib':playerlib.getPlayer(userid)}
        else:
            if Players[userid]['character']:
                __Players[userid]['Character'].key = Characters[Players[userid]['character']]
        #if es.isbot(userid):
        #    __Players[userid]['Player'].key['character'] = 'Fighter'
        return __Players[userid]
    else:
        return None
def delPlayer(userid):
    userid = int(userid)
    #global __Players
    if userid in __Players:
        del __Players[userid]
        gc.collect()
#End global methods
#Begin Classes
#Our menu class, handels all static and dynamic menus
class Menu(object):
    def __init__(self, userid):
        report('Start Menu init')
        self.userid = int(userid)
        report('End Menu init')
    def Unsend(self):
        if not es.isbot(self.userid):
            count = popuplib.active(self.userid)['count']
            #es.msg(popuplib.active(self.userid))
            while count > 0:
                count -= 1
                if popuplib.active(self.userid)['name'] != '0':
                    popuplib.close(popuplib.active(self.userid)['name'], self.userid)
    def MainMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        MMenu = popuplib.create('MMenu')
        for i in range(1, 11):
            MMenu.addline(text('MainMenu %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        MMenu.menuselect = self.MainMenuSelect
        MMenu.send(self.userid)
    def MainMenuSelect(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            if getPlayer(self.userid)['playerlib'].get('isdead') or int(es.getplayerteam(self.userid)) == 1:
                es.tell(self.userid, '#multi', text('MainMenuSelect 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
                es.escinputbox(10, self.userid, text('MainMenuSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')), text('MainMenuSelect 3',{},getPlayer(self.userid)['playerlib'].get('lang')), 'dnd create')
            else:
                es.tell(self.userid, '#multi', text('MainMenuSelect 4',{},getPlayer(self.userid)['playerlib'].get('lang')))
        elif choice == 2:
            self.CharacterMenu()
        elif choice == 3:
            self.CharacterInformation()
        elif choice == 4:
            if getPlayer(self.userid)['Character'].key['password'] == 'locked':
                es.escinputbox(10, self.userid, text('MainMenuSelect 5',{},getPlayer(self.userid)['playerlib'].get('lang')), text('MainMenuSelect 6',{},getPlayer(self.userid)['playerlib'].get('lang')), 'dnd passwordset ')
            else:
                es.tell(self.userid, '#multi', text('MainMenuSelect 7',{},getPlayer(self.userid)['playerlib'].get('lang')))
        elif choice == 5:
            if getPlayer(self.userid)['Character'].key['password'] != 'public':
                sure = popuplib.create('sure')
                for i in range(8, 11):
                    sure.addline(text('MainMenuSelect %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
                sure.menuselect = self.MakePublic
                sure.send(self.userid)
            else:
                es.tell(self.userid, '#multi', text('MainMenuSelect 11',{},getPlayer(self.userid)['playerlib'].get('lang')))
        elif choice == 6:
            getPlayer(self.userid)['Player'].DelCharacterMenu()
        elif choice == 7:
            self.InfoMenu()
        elif choice == 8:
            self.HelpMenu()
    def CharacterMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        cm = popuplib.create('cmenu')
        for i in range(1, 7):
            cm.addline(text('CharactersMenu %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        cm.menuselect = self.CharacterMenuSelect
        cm.send(self.userid)
    def CharacterMenuSelect(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            getPlayer(self.userid)['Player'].CharacterMenu()
        elif choice == 2:
            self.PublicCharacters()
        elif choice == 3:
            self.DemoCharacters()
        elif choice >= 4 and choice <= 8:
            self.CharacterMenu()
        elif choice == 9:
            self.MainMenu()
    def DemoCharacters(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        dc = popuplib.easymenu('dc menu', None, self.DemoCharacterSelect)
        dc.settitle(text('DemoCharacters 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for clas in Class_List:
            dc.addoption(clas, clas)
        dc.addoption('back', text('DemoCharacters 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        dc.send(self.userid)
    def DemoCharacterSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'back':
            self.CharacterMenu()
        else:
            getPlayer(self.userid)['Player'].key['character'] = choice
    def PublicCharacters(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        if not choice:
            pcs = popuplib.easymenu('pcs',None,self.PublicCharactersSelect)
        else:
            pcs = popuplib.easymenu('pcs',None,self.CharacterInformation)
        pcs.settitle(text('PublicCharacters 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        if len(Public_Characters):
            for c in sorted(Public_Characters):
                if not getPlayer(self.userid)['Player'].LoopCharacter(c):
                    pcs.addoption(c, c)
        if not choice:
            pcs.addoption('back main', text('PublicCharacters 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            pcs.addoption('back info', text('PublicCharacters 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        pcs.send(self.userid)
    def PublicCharactersSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'back main':
            self.MainMenu()
        else:
            es.cexec(self.userid, 'dnd', 'load %s'%choice)
    def MakePublic(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            self.Unsend()
            mps = popuplib.create('mpsinfo')
            for i in range(1, 5):
                mps.addline(text('MakePublic %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
            mps.menuselect = self.MakePublicSelect
            mps.send(self.userid)
    def MakePublicSelect(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            getPlayer(self.userid)['Character'].key['password'] = 'public'
            Public_Characters.append(getPlayer(self.userid)['Player'].key['character'])
            es.tell(self.userid, '#multi', text('MakePublicSelect 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
    def CharacterInformation(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        if not choice:
            character = getPlayer(self.userid)['Player'].key['character']
        elif choice == 'back info':
            self.InfoMenu()
        else:
            character = choice
            getPlayer(self.userid)['Player'].key['pending'] = choice
        if choice != 'back info':
            statsmenu = popuplib.create('statsmenu')
            statsmenu.addline(text('CharacterInformation 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
            statsmenu.addline(text('CharacterInformation 2',{'character':character},getPlayer(self.userid)['playerlib'].get('lang')))
            statsmenu.addline(text('CharacterInformation 3',{'xp':Characters[character]['xp'],'needed':Levels[Characters[character]['level']+1]},getPlayer(self.userid)['playerlib'].get('lang')))
            statsmenu.addline(text('CharacterInformation 4',{'race':Characters[character]['race']},getPlayer(self.userid)['playerlib'].get('lang')))
            statsmenu.addline(text('CharacterInformation 5',{},getPlayer(self.userid)['playerlib'].get('lang')))
            for c in sorted(Characters[character]['classes'].keys()):
                statsmenu.addline(' - %s (Level %s)'%(c, Characters[character]['classes'][c]['level']))
            statsmenu.addline('Abilities:')
            abilities = Characters[character]['abilities']
            for a in Ability_List:
                statsmenu.addline(' - %s (%s)'%(a, abilities[a]))
            statsmenu.addline(text('CharacterInformation 6',{},getPlayer(self.userid)['playerlib'].get('lang')))
            statsmenu.addline(text('CharacterInformation 7',{},getPlayer(self.userid)['playerlib'].get('lang')))
            statsmenu.addline(text('CharacterInformation 8',{},getPlayer(self.userid)['playerlib'].get('lang')))
            statsmenu.menuselect = self.CISelect
            statsmenu.send(self.userid)
    def CISelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            if not getPlayer(self.userid)['Player'].key['pending']:
                self.MainMenu()
            else:
                self.PublicCharacters(choice='info')
        elif choice == 8:
            self.ShowFeats()
    def ShowFeats(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        if getPlayer(self.userid)['Player'].key['pending'] in Characters:
            character = getPlayer(self.userid)['Player'].key['pending']
        else:
            character = getPlayer(self.userid)['Player'].key['character']
        sfmenu = popuplib.create('sfmenu')
        sfmenu.addline(text('ShowFeats 1',{'character':character},getPlayer(self.userid)['playerlib'].get('lang')))
        for f in Characters[character]['feats']:
            sfmenu.addline(' - %s'%f)
        sfmenu.addline(text('ShowFeats 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        sfmenu.addline(text('ShowFeats 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        sfmenu.menuselect = self.ShowFeatsSelect
        sfmenu.send(self.userid)
    def ShowFeatsSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.CharacterInformation(choice=getPlayer(self.userid)['Player'].key['pending'])
    def HelpMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        welcomemenu = popuplib.create('welcomemenu')
        for i in range(1, 11):
            welcomemenu.addline(text('HelpMenu %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        welcomemenu.menuselect = self.MainMenu
        welcomemenu.send(self.userid)
    def InfoMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        infomenu = popuplib.create('infomenu')
        for i in range(1, 12):
            infomenu.addline(text('InfoMenu %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        infomenu.menuselect = self.InfoSelect
        infomenu.send(self.userid)
    def InfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.MainMenu()
        elif choice == 8:
            self.ModInfo()
        elif choice == 7:
            self.GeneralInfo()
        elif choice == 6:
            self.PublicCharacters(choice='info')
        elif choice == 5:
            self.ParaInfoStart()
        elif choice == 4:
            self.FeatInfo()
        elif choice == 3:
            self.StatInfo()
        elif choice == 2:
            self.ClassInfo()
        elif choice == 1:
            self.RaceInfo()
    def ParaInfoStart(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        CMenu = popuplib.easymenu('Class menu', None, self.ParaInfoStartSelect)
        CMenu.settitle(text('ClassMenu 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for Class in Class_List:
            CMenu.addoption(Class, Class)
        CMenu.addoption('info', text('ClassMenu 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        CMenu.send(self.userid)
    def ParaInfoStartSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'info':
            self.InfoMenu()
        else:
            PAMenu = popuplib.easymenu('Para Menu', None, self.ParaInfoSelect)
            PAMenu.settitle(text('ParaInfoStartSelect 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
            for pa in Classes[choice]['paragon paths']:
                PAMenu.addoption(pa, pa)
            PAMenu.addoption('back', text('ParaInfoStartSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            PAMenu.send(self.userid)
    def ParaInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'back':
            self.ParaInfoStart()
        else:
            getPlayer(self.userid)['Player'].key['pending'] = choice
            PIMenu = popuplib.create('PIMenu')
            PIMenu.addline(text('ParaInfoSelect 1',{'choice':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            for C in Classes:
                if choice in Classes[C]['paragon paths']:
                    for line in Classes[C]['paragon paths'][choice]:
                        PIMenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            PIMenu.addline(text('ParaInfoSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            PIMenu.addline(text('ParaInfoSelect 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            PIMenu.menuselect = self.ParaInfoSS
            PIMenu.send(self.userid)
    def ParaInfoSS(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.ParaInfoStart()
    def FeatInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        fmenu = popuplib.easymenu('fmenu',None,self.FeatInfoSelect)
        fmenu.settitle(text('FeatInfo 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        counter = 0
        for f in Feat_List:
            counter += 1
            fmenu.addoption(f, f)
            if counter == 6:
                if 'unspent' in getPlayer(self.userid)['Character'].key['feats']:
                    fmenu.addoption('pick', text('FeatInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
                else:
                    fmenu.addoption('back', text('FeatInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        if counter < 6:
            if 'unspent' in getPlayer(self.userid)['Character'].key['feats']:
                fmenu.addoption('pick', text('FeatInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            else:
                fmenu.addoption('back', text('FeatInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        fmenu.send(self.userid)
    def FeatInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'pick':
            self.FeatMenu()
        elif choice == 'back':
            self.InfoMenu()
        else:
            finfo = popuplib.create('finfo')
            finfo.addline(text('FeatInfoSelect 1',{'feat':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Feats[choice]['info']:
                report('Line = %s'%line)
                finfo.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            finfo.addline(text('FeatInfoSelect 2',{'feat':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            finfo.addline(text('FeatInfoSelect 3',{'feat':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            finfo.menuselect = self.FeatInfoChoiceSelect
            finfo.send(self.userid)
    def FeatInfoChoiceSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.FeatInfo()
        elif choice != 0:
            self.FeatInfo()
    def ModInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        modinfo = popuplib.create('modinfo')
        for i in range(1, 9):
            modinfo.addline(text('ModInfo %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        modinfo.menuselect = self.ModInfoSelect
        modinfo.send(self.userid)
    def ModInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.InfoMenu()
    def GeneralInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        geninfo = popuplib.create('geninfo')
        for i in range(1, 9):
            geninfo.addline(text('GeneralInfo %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        geninfo.menuselect = self.GeneralInfoSelect
        geninfo.send(self.userid)
    def GeneralInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.InfoMenu()
        elif choice == 1:
            self.CustomCommands()
        elif choice == 2:
            self.PasswordedCharacters()
        elif choice == 3:
            self.PublicCharactersInfo()
        elif choice == 4:
            self.DemoCharactersInfo()
        elif choice == 5:
            self.TermsInfo()
    def DemoCharactersInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        dcinfo = popuplib.create('dcinfo')
        for i in range(1, 8):
            dcinfo.addline(text('DemoCharactersInfo %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        dcinfo.menuselect = self.DemoCharactersInfoSelect
        dcinfo.send(self.userid)
    def DemoCharactersInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.GeneralInfo()
        elif choice >= 1 and choice <= 8:
            self.DemoCharactersInfo()
    def TermsInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        tinfo = popuplib.create('tinfo')
        for i in range(1, 7):
            tinfo.addline(text('TermsInfo %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        tinfo.menuselect = self.TermsInfoSelect
        tinfo.send(self.userid)
    def TermsInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.GeneralInfo()
    def PasswordedCharacters(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        pwdinfo = popuplib.create('pwdinfo')
        for i in range(1, 10):
            pwdinfo.addline(text('PasswordedCharacters %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        pwdinfo.menuselect = self.PasswordedCharactersSelect
        pwdinfo.send(self.userid)
    def PasswordedCharactersSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.GeneralInfo()
    def PublicCharactersInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        pwdinfo = popuplib.create('pwdinfo')
        for i in range(1, 9):
            pwdinfo.addline(text('PublicCharactersInfo %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        pwdinfo.menuselect = self.PublicCharactersInfoSelect
        pwdinfo.send(self.userid)
    def PublicCharactersInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.GeneralInfo()
    def CustomCommands(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        ccinfo = popuplib.create('ccinfo')
        for i in range(1, 7):
            ccinfo.addline(text('CustomCommands %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        ccinfo.menuselect = self.CustomCommandsSelect
        ccinfo.send(self.userid)
    def CustomCommandsSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.GeneralInfo()
    def StatInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        SMenu = popuplib.easymenu('stat info', None, self.StatInfoSelect)
        SMenu.settitle(text('StatInfo 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for stat in Ability_List:
            SMenu.addoption(stat, stat)
        if getPlayer(self.userid)['Player'].key['pending'] == 'Stat':
            SMenu.addoption('pick', text('StatInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            SMenu.addoption('back', text('StatInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        SMenu.send(self.userid)
    def StatInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'back':
            self.InfoMenu()
        elif choice == 'pick':
            self.StatMenu()
        else:
            infomenu = popuplib.create('%s info'%choice)
            infomenu.addline(text('StatInfoSelect 1',{'choice':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Abilities[choice]['info']:
                infomenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.addline(text('StatInfoSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.addline(text('StatInfoSelect 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.menuselect = self.InfoStatSelect
            infomenu.send(self.userid)
        getPlayer(self.userid)['Player'].key['pending'] = None
    def InfoStatSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.StatInfo()
    def StatMenu(self, userid=None, choice=None, popupid=None):
        report('running unsend')
        self.Unsend()
        report('building stats popup')
        statmenu = popuplib.create('stats')
        for i in range(1, 5):
            statmenu.addline(text('StatMenu %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        report('assigning menuselect for stats')
        statmenu.menuselect = self.StatSelect
        report('sending stats popup')
        statmenu.send(self.userid)
    def StatSelect(self, userid=None, choice=None, popupid=None):
        if choice == 3:
            getPlayer(self.userid)['Player'].key['pending'] = 'Stat'
            self.StatInfo()
        elif choice == 2:
            self.StatManual()
        elif choice == 1:
            classes = getPlayer(self.userid)['Character'].key['classes'].keys()
            if 'Cleric' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':14,
                                        'Constitution':12,
                                        'Dexterity':11,
                                        'Intelligence':10,
                                        'Wisdom':16,
                                        'Charisma':13}
            elif 'Fighter' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':14,
                                        'Constitution':16,
                                        'Dexterity':13,
                                        'Intelligence':10,
                                        'Wisdom':12,
                                        'Charisma':11}
            elif 'Paladin' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':16,
                                        'Constitution':14,
                                        'Dexterity':11,
                                        'Intelligence':10,
                                        'Wisdom':12,
                                        'Charisma':13}
            elif 'Ranger' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':14,
                                        'Constitution':12,
                                        'Dexterity':16,
                                        'Intelligence':11,
                                        'Wisdom':13,
                                        'Charisma':10}
            elif 'Rogue' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':12,
                                        'Constitution':13,
                                        'Dexterity':16,
                                        'Intelligence':14,
                                        'Wisdom':11,
                                        'Charisma':10}
            elif 'Warlock' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':11,
                                        'Constitution':16,
                                        'Dexterity':12,
                                        'Intelligence':14,
                                        'Wisdom':10,
                                        'Charisma':13}
            elif 'Warlord' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':16,
                                        'Constitution':12,
                                        'Dexterity':11,
                                        'Intelligence':13,
                                        'Wisdom':10,
                                        'Charisma':14}
            elif 'Wizard' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':10,
                                        'Constitution':14,
                                        'Dexterity':13,
                                        'Intelligence':16,
                                        'Wisdom':12,
                                        'Charisma':11}
            else:
                self.ClassMenu()
            if len(classes):
                self.RaceMenu()
            for x in Ability_List:
                es.tell(self.userid, '#multi', text('StatSet',{'stat':x,'amount':getPlayer(self.userid)['Character'].key['abilities'][x]},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            self.StatMenu()
    def StatManual(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        AMenu = popuplib.easymenu('atmenu', None, self.StatManualSelect)
        abilities = getPlayer(self.userid)['Character'].key['abilities']
        count = 0
        for a in Ability_List:
            if not abilities[a]:
                count += 1
                AMenu.addoption(a, a)
        key = {6:16,5:14,4:13,3:12,2:11,1:10}
        if count:
            AMenu.settitle('Select a stat to set to %s'%key[count])
            getPlayer(self.userid)['Player'].key['pending'] = key[count]
            AMenu.send(self.userid)
        else:
            self.RaceMenu()
    def StatManualSelect(self, userid=None, choice=None, popupid=None):
        es.tell(self.userid, '#multi', text('StatSet',{'stat':choice,'amount':getPlayer(self.userid)['Player'].key['pending']},getPlayer(self.userid)['playerlib'].get('lang')))
        getPlayer(self.userid)['Character'].key['abilities'][choice] = getPlayer(self.userid)['Player'].key['pending']
        self.StatManual()
    def RaceMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        RMenu = popuplib.easymenu('race menu', None, self.RaceSelect)
        RMenu.settitle(text('RaceMenu 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for race in Race_List:
            RMenu.addoption(race, race)
        RMenu.addoption('info', text('RaceMenu 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        RMenu.send(self.userid)
    def RaceSelect(self, userid=None, choice=None, popupid=None):
        if choice != 'info':
            getPlayer(self.userid)['Character'].key['race'] = choice
            es.tell(self.userid, '#multi', text('RaceSelect 1',{'race':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            abilities = getPlayer(self.userid)['Character'].key['abilities']
            if choice == 'Dragonborn':
                abilities['Strength'] += 2
                abilities['Charisma'] += 2
            elif choice == 'Dwarf':
                abilities['Constitution'] += 2
                abilities['Wisdom'] += 2
            elif choice == 'Eladrin':
                abilities['Dexterity'] += 2
                abilities['Intelligence'] += 2
            elif choice == 'Elf':
                abilities['Dexterity'] += 2
                abilities['Wisdom'] += 2
            elif choice == 'Half Elf':
                abilities['Constitution'] += 2
                abilities['Charisma'] += 2
            elif choice == 'Halfling':
                abilities['Dexterity'] += 2
                abilities['Charisma'] += 2
            elif choice == 'Human':
                getPlayer(self.userid)['Character'].key['stat increase'].append([2, text('RaceSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang'))])
                getPlayer(self.userid)['Character'].key['feats'].append('unspent')
                self.IncreaseStat()
            elif choice == 'Tiefling':
                abilities['Intelligence'] += 2
                abilities['Charisma'] += 2
            if choice != 'Human':
                self.FeatMenu()
        else:
            self.RaceInfo()
    def FeatMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        if 'unspent' in getPlayer(self.userid)['Character'].key['feats']:
            fmenu = popuplib.easymenu('fmenu',None,self.FeatMenuSelect)
            fmenu.settitle(text('FeatMenu 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
            Character = getPlayer(self.userid)['Character']
            for f in Feat_List:
                if f not in Character.key['feats']:
                    Req = Feats[f]['requirements']
                    Good = 1
                    for a in Req['abilities']:
                        if Character.key['abilities'][a] < Req['abilities'][a]:
                            Good = 0
                    if Character.key['race'] not in Req['races'] and len(Req['races']):
                        Good = 0
                    for c in Req['classes']:
                        if c in Character.key['classes']:
                            if Character.key['classes'][c]['level'] < Req['classes'][c]:
                                Good = 0
                                break
                        else:
                            Good = 0
                    for f in Req['feats']:
                        if f not in Character.key['feats']:
                            Good = 0
                    if Req['level'] > Character.key['level']:
                        Good = 0
                    for c in Req['banned classes']:
                        if c in Character.key['classes']:
                            Good = 0
                            break
                    if Good:
                        fmenu.addoption(f, f)
            fmenu.addoption('info',text('FeatMenu 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            fmenu.send(self.userid)
    def FeatMenuSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'info':
            self.FeatInfo()
        else:
            Character = getPlayer(self.userid)['Character']
            Character.key['feats'].remove('unspent')
            Character.key['feats'].append(choice)
            es.tell(self.userid, '#multi',text('FeatMenuSelect 1',{'feat':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            self.IncreaseStat()
            self.FeatMenu()
    def IncreaseStat(self, userid=None, choice=None, popupid=None):
        if len(getPlayer(self.userid)['Character'].key['stat increase']):
            self.Unsend()
            if 'last stat' not in getPlayer(self.userid)['Character'].key:
                getPlayer(self.userid)['Character'].key['last stat'] = None
            si = getPlayer(self.userid)['Character'].key['stat increase'][0]
            abilities = getPlayer(self.userid)['Character'].key['abilities']
            AMenu = popuplib.easymenu('amenu', None, self.IncreaseStatSelect)
            AMenu.settitle(text('IncreaseStat 1',{'amount':si[0],'reason':si[1]},getPlayer(self.userid)['playerlib'].get('lang')))
            for a in Ability_List:
                if a != getPlayer(self.userid)['Character'].key['last stat']:
                    AMenu.addoption((a,si[0]), '%s (%s)'%(a,abilities[a]))
            AMenu.send(self.userid)
    def IncreaseStatSelect(self, userid=None, choice=None, popupid=None):
        getPlayer(self.userid)['Character'].key['abilities'][choice[0]] += choice[1]
        getPlayer(self.userid)['Character'].key['last stat'] = choice[0]
        es.tell(self.userid, '#multi', text('IncreaseStatSelect 1',{'stat':choice[0],'value':getPlayer(self.userid)['Character'].key['abilities'][choice[0]]},getPlayer(self.userid)['playerlib'].get('lang')))
        getPlayer(self.userid)['Character'].key['stat increase'].remove(getPlayer(self.userid)['Character'].key['stat increase'][0])
        self.FeatMenu()
        self.IncreaseStat()
    def RaceInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        RMenu = popuplib.easymenu('race info', None, self.RaceInfoSelect)
        RMenu.settitle(text('RaceInfo 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for race in Race_List:
            RMenu.addoption(race, race)
        if getPlayer(self.userid)['Character'].key['race'] == 'Pending':
            RMenu.addoption('pick', text('RaceInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            RMenu.addoption('back', text('RaceInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        RMenu.send(self.userid)
    def RaceInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'pick':
            self.RaceMenu()
        elif choice == 'back':
            self.InfoMenu()
        else:
            infomenu = popuplib.create('%s info'%choice)
            infomenu.addline(text('RaceInfoSelect 1',{'choice':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Races[choice]['info']:
                infomenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            if getPlayer(self.userid)['Character'].key['race'] == 'Pending':
                getPlayer(self.userid)['Player'].key['pending'] = choice
                infomenu.addline(text('RaceInfoSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.addline(text('RaceInfoSelect 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.addline(text('RaceInfoSelect 4',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.menuselect = self.InfoRaceSelect
            infomenu.send(self.userid)
    def InfoRaceSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8 and getPlayer(self.userid)['Player'].key['pending'] and getPlayer(self.userid)['Character'].key['race'] == 'Pending':
            self.RaceSelect(choice=getPlayer(self.userid)['Player'].key['pending'])
        elif choice == 9:
            self.RaceInfo()
        getPlayer(self.userid)['Player'].key['pending'] = None
    def ClassMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        CMenu = popuplib.easymenu('Class menu', None, self.ClassSelect)
        CMenu.settitle(text('ClassMenu 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for Class in Class_List:
            CMenu.addoption(Class, Class)
        CMenu.addoption('info', text('ClassMenu 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        CMenu.send(self.userid)
    def ClassSelect(self, userid=None, choice=None, popupid=None):
        if choice != 'info':
            report('sending statmenu')
            if choice != 'Ranger':
                self.StatMenu()
            else:
                self.RangerType()
            report('setting %s to level 1'%choice)
            if not len(getPlayer(self.userid)['Character'].key['classes']):
                getPlayer(self.userid)['Character'].key['classes'][choice] = {'level':1}
                report('sending classselect message')
                es.tell(self.userid, '#multi', text('ClassSelect 1',{'class':choice},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            self.ClassInfo()
    def ClassInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        CMenu = popuplib.easymenu('Class info', None, self.ClassInfoSelect)
        CMenu.settitle(text('ClassInfo 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for Class in Class_List:
            CMenu.addoption(Class, Class)
        if not getPlayer(self.userid)['Character'].key['classes']:
            CMenu.addoption('pick', text('ClassInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            CMenu.addoption('back', text('ClassInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        CMenu.send(self.userid)
    def ClassInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'pick':
            self.ClassMenu()
        elif choice == 'back':
            self.InfoMenu()
        else:
            infomenu = popuplib.create('%s info'%choice)
            infomenu.addline(text('ClassInfoSelect 1',{'choice':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Classes[choice]['info']:
                infomenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            if not getPlayer(self.userid)['Character'].key['classes']:
                infomenu.addline(text('ClassInfoSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            getPlayer(self.userid)['Player'].key['pending'] = choice
            infomenu.addline(text('ClassInfoSelect 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.addline(text('ClassInfoSelect 4',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.menuselect = self.InfoClassSelect
            infomenu.send(self.userid)
    def InfoClassSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8 and not getPlayer(self.userid)['Character'].key['classes']:
            self.ClassSelect(choice=getPlayer(self.userid)['Player'].key['pending'])
        elif choice == 9:
            self.ClassInfo()
        elif choice == 4:
            self.Powers4Info()
        elif choice == 3:
            self.Powers3Info()
        elif choice == 2:
            self.Powers2Info()
        elif choice == 1:
            self.Powers1Info()
        if choice != 1 and choice != 2 and choice != 3 and choice != 4:
            getPlayer(self.userid)['Player'].key['pending'] = None
    def Powers1Info(self, userid=None, choice=None, popupid=None):
        Class = getPlayer(self.userid)['Player'].key['pending']
        if Class != 'Ranger' or choice:
            if choice:
                name = choice.split(' ')[0]
            else:
                name = Class
            imenu = popuplib.create('imenu')
            imenu.addline(text('PowersInfo 1',{'class':Class,'levels':'1-5'},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Classes[name]['powers1']:
                if name != 'Ranger':
                    imenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
                else:
                    if choice in line:
                        imenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.addline(text('PowersInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.addline(text('PowersInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.menuselect = self.PowersInfoSelect
            imenu.send(self.userid)
        elif Class == 'Ranger':
            self.RangerTypeInfo(choice=1)
    def Powers2Info(self, userid=None, choice=None, popupid=None):
        Class = getPlayer(self.userid)['Player'].key['pending']
        if Class != 'Ranger' or choice:
            if choice:
                name = choice.split(' ')[0]
            else:
                name = Class
            imenu = popuplib.create('imenu')
            imenu.addline(text('PowersInfo 1',{'class':Class,'levels':'6-10'},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Classes[name]['powers2']:
                if name != 'Ranger':
                    imenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
                else:
                    if choice in line:
                        imenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.addline(text('PowersInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.addline(text('PowersInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.menuselect = self.PowersInfoSelect
            imenu.send(self.userid)
        elif Class == 'Ranger':
            self.RangerTypeInfo(choice=2)
    def Powers3Info(self, userid=None, choice=None, popupid=None):
        Class = getPlayer(self.userid)['Player'].key['pending']
        if Class != 'Ranger' or choice:
            if choice:
                name = choice.split(' ')[0]
            else:
                name = Class
            imenu = popuplib.create('imenu')
            imenu.addline(text('PowersInfo 1',{'class':Class,'levels':'11-15'},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Classes[name]['powers3']:
                if name != 'Ranger':
                    imenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
                else:
                    if choice in line:
                        imenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.addline(text('PowersInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.addline(text('PowersInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.menuselect = self.PowersInfoSelect
            imenu.send(self.userid)
        elif Class == 'Ranger':
            self.RangerTypeInfo(choice=2)
    def Powers4Info(self, userid=None, choice=None, popupid=None):
        Class = getPlayer(self.userid)['Player'].key['pending']
        if Class != 'Ranger' or choice:
            if choice:
                name = choice.split(' ')[0]
            else:
                name = Class
            imenu = popuplib.create('imenu')
            imenu.addline(text('PowersInfo 1',{'class':Class,'levels':'16-20'},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Classes[name]['powers4']:
                if name != 'Ranger':
                    imenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
                else:
                    if choice in line:
                        imenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.addline(text('PowersInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.addline(text('PowersInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            imenu.menuselect = self.PowersInfoSelect
            imenu.send(self.userid)
        elif Class == 'Ranger':
            self.RangerTypeInfo(choice=4)
    def PowersInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.ClassInfoSelect(choice=getPlayer(self.userid)['Player'].key['pending'])
        else:
            getPlayer(self.userid)['Player'].key['pending'] = None
    def ParagonMenu(self, userid=None, choice=None, popupid=None):
        PAMenu = popuplib.easymenu('pa menu',None,self.ParagonMenuSelect)
        PAMenu.settitle(text('ParagonMenu 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for PA in Classes[getPlayer(self.userid)['Character'].key['classes'].keys()[0]]['paragon paths']:
            PAMenu.addoption(PA, PA)
        PAMenu.addoption('multi class', text('ParagonMenu 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        PAMenu.send(self.userid)
    def ParagonMenuSelect(self, userid=None, choice=None, popupid=None):
        getPlayer(self.userid)['Character'].key['paragon path'] = choice
        if choice == 'multi class':
            self.MultiMenu()
        else:
            getPlayer(userid)['Character'].GiveLevel(1)
    def MultiMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        CMenu = popuplib.easymenu('Class menu', None, self.MultiSelect)
        CMenu.settitle(text('MultiMenu 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for Class in Class_List:
            if Class not in getPlayer(self.userid)['Character'].key['classes']:
                CMenu.addoption(Class, Class)
        CMenu.send(self.userid)
    def MultiSelect(self, userid=None, choice=None, popupid=None):
        getPlayer(self.userid)['Character'].key['classes'][choice] = {'level':1}
        getPlayer(self.userid)['Character'].key['level'] += 1
        es.tell(self.userid, '#multi', text('MultiSelect 1',{'class':choice},getPlayer(self.userid)['playerlib'].get('lang')))
    def RangerType(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        rmenu = popuplib.create('rang menu')
        rmenu.addline('What Type of Ranger Would You Like to Player as:')
        rmenu.addline('-> 1. Two Weapon Fighting')
        rmenu.addline('-> 2. Archer')
        rmenu.menuselect = self.RangerTypeSelect
        rmenu.send(self.userid)
    def RangerTypeSelect(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            getPlayer(self.userid)['Character'].key['weapon type'] = 'two weapon'
            es.tell(self.userid, '#multi', text('RangerTypeSelect 1',{'type':'Two Weapon'},getPlayer(self.userid)['playerlib'].get('lang')))
            self.StatMenu()
        elif choice == 2:
            getPlayer(self.userid)['Character'].key['weapon type'] = 'archer'
            es.tell(self.userid, '#multi', text('RangerTypeSelect 1',{'type':'Archer'},getPlayer(self.userid)['playerlib'].get('lang')))
            self.StatMenu()
        else:
            self.RangerType()
    def RangerTypeInfo(self, userid=None, choice=None, popupid=None):
        rtinfo = popuplib.easymenu('rtimenu',None,self.RangerTypeInfoSelect)
        rtinfo.settitle(text('RangerTypeInfo 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        rtinfo.addoption(('archer',choice), 'Archer Powers')
        rtinfo.addoption(('two',choice), 'Two Weapon Powers')
        rtinfo.addoption(('back',choice), 'To Ranger Info Menu')
        rtinfo.send(self.userid)
    def RangerTypeInfoSelect(self, userid=None, choice=None, popupid=None):
        send = None
        if choice[0] == 'archer':
            send = 'Ranger Archer'
        elif choice[0] == 'two':
            send = 'Ranger Two Weapon'
        elif choice[0] == 'back':
            self.ClassInfoSelect(choice='Ranger')
        if choice[1] == 1:
            self.Powers1Info(choice=send)
        elif choice[1] == 2:
            self.Powers2Info(choice=send)
        elif choice[1] == 3:
            self.Powers3Info(choice=send)
        elif choice[1] == 4:
            self.Powers4Info(choice=send)
#Begin Player Class
class Player(object):
    global Players
    def __init__(self, userid):
        report('Start player init')
        self.userid = int(userid)
        self.steamid = playerlib.uniqueid(self.userid, True)
        if self.userid not in Players:
            Players[self.userid] = {}
            Players[self.userid]['character'] = None
            Players[self.userid]['pending'] = None
            Players[self.userid]['characters list'] = []
            Players[self.userid]['delay list'] = []
            Players[self.userid]['gravity'] = 1.0
            Players[self.userid]['long jump'] = 1.0
        self.key = Players[self.userid]
        report('End player init')
    def KeySet(self, key, value):
        self.key[key] = value
    def KeyMod(self, key, value):
        self.key[key] += value
    def CheckCharacter(self):
        for x in Characters:
            if Characters[x]['creator'] == self.steamid:
                if not self.key['character']:
                    self.key['character'] = x
                if x not in self.key['characters list']:
                    self.key['characters list'].append(x)
        if not self.key['character']:
            getPlayer(self.userid)['Character'].Setup(es.getplayername(self.userid), 1)
    def AddCharacter(self, Name):
        self.key['characters list'].append(Name)
        self.key['character'] = Name
    def SetCharacter(self, Name):
        if Name in Characters:
            if not self.LoopCharacter(Name):
                self.key['character'] = Name
                es.tell(self.userid, '#multi', text('SetCharacter 1',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
            else:
                es.tell(self.userid, '#multi', text('SetCharacter 2',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            es.tell(self.userid, '#multi', text('SetCharacter 3',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
    def LoopCharacter(self, Name):
        for x in es.getUseridList():
            if Players[x]['character'] == Name and Character[Name]['password'] != 'demo':
                return 1
        return 0
    def TempCharacter(self, Name):
        if Name in Characters:
            if Characters[Name]['password'] != 'locked':
                self.key['pending'] = Name
                es.tell(self.userid, '#multi', text('TempCharacter 1',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
                es.escinputbox(10, self.userid, text('TempCharacter 2',{},getPlayer(self.userid)['playerlib'].get('lang')), text('TempCharacter 3',{},getPlayer(self.userid)['playerlib'].get('lang')), 'dnd passwordenter')
            else:
                es.tell(self.userid, '#multi', text('TempCharacter 3',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            es.tell(self.userid, '#multi', text('TempCharacter 4',{},getPlayer(self.userid)['playerlib'].get('lang')))
    def PasswordEnter(self, Password):
        if self.key['pending']:
            if Password == Characters[self.key['pending']]['password']:
                self.SetCharacter(self.key['pending'])
            else:
                es.tell(self.userid, '#multi', text('PasswordEnter 1',{'password':Password,'pending':self.key['pending']},getPlayer(self.userid)['playerlib'].get('lang')))
            self.key['pending'] = None
        else:
            es.tell(self.userid, '#multi', text('PasswordEnter 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
    def CharacterMenu(self):
        CMenu = popuplib.easymenu('CMenu', None, self.CharacterMenuSelect)
        CMenu.settitle(text('CharacterMenu 1',{'name':es.getplayername(self.userid)},getPlayer(self.userid)['playerlib'].get('lang')))
        for x in self.key['characters list']:
            if x != self.key['character']:
                CMenu.addoption(x, x)
        CMenu.send(self.userid)
    def CharacterMenuSelect(self, userid, choice, popupid):
        es.sexec(self.userid, 'dnd load %s'%choice)
    def DelCharacterMenu(self):
        CMenu = popuplib.easymenu('CMenu', None, self.DelCharacterMenuSelect)
        CMenu.settitle(text('DelCharacterMenu 1',{'name':es.getplayername(self.userid)},getPlayer(self.userid)['playerlib'].get('lang')))
        for x in self.key['characters list']:
            if x != self.key['character']:
                CMenu.addoption(x, x)
        CMenu.send(self.userid)
    def DelCharacterMenuSelect(self, userid, choice, popupid):
        SMenu = popuplib.easymenu('sure Menu', None, self.DelSureSelect)
        SMenu.settitle(text('DelCharacterMenuSelect 1',{'name':choice},getPlayer(self.userid)['playerlib'].get('lang')))
        SMenu.addoption(choice, 'Yes')
        SMenu.addoption('No', 'No')
        SMenu.send(self.userid)
    def DelSureSelect(self, userid, choice, popupid):
        if choice != 'No':
            self.key['characters list'].remove(choice)
            del Characters[choice]
            es.tell(self.userid, '#multi', text('DelSureSelect 1',{'name':choice},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            es.tell(self.userid, '#multi', text('DelSureSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
    def Delayed(self, duration, function, parama=(), Endround=None):
        if not Endround:
            gamethread.delayedname(duration, len(self.key['delay list'])+1, function, parama)
            self.key['delay list'].append(len(self.key['delay list'])+1)
        else:
            gamethread.delayedname(duration, len(Players['delay list'])+1, function, parama)
            Players['delay list'].append(len(Players['delay list'])+1)
    def Freeze(self, duration=None):
        self.key['freeze'] += 1
        es.setplayerprop(self.userid, "CBasePlayer.m_fFlags", 32.0)
        if duration:
            gamethread.delayed(duration, self.Unfreeze)
    def Unfreeze(self):
        if self.key['freeze'] > 0:
            self.key['freeze'] -= 1
        else:
            self.key['freeze'] = 0
        if not self.key['freeze']:
            es.setplayerprop(self.userid, "CBasePlayer.m_fFlags", 1)
    def Damage(self, damage, attacker, corelib=0):
        Health = int(es.getplayerprop(self.userid, 'CBasePlayer.m_iHealth'))
        report('Attacker: %s - Victim: %s - Damage: %s'%(es.getplayername(attacker), es.getplayername(self.userid), damage))
        if Health <= damage:
            #if not corelib:
            #    es.server.queuecmd('est_damage %s %s %s'%(attacker, self.userid, damage))
            #else:
            es.server.queuecmd('damage %s %s 32 %s'%(self.userid, damage, attacker))
        else:
            es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', Health-damage)
            #if gamevar:
                #def PlayerHurt(userid, attacker, damage, weapon, Classes, Character, Paragon):
            #    gamevar.PlayerHurt(self.userid, attacker, damage, 'point_hurt', getPlayer(self.userid)['Character'].key['classes'].keys(), getPlayer(self.userid)['Character'], getPlayer(self.userid)['Character'].key['paragon path'])
    def NearList(self, distance):
        x1,y1,z1 = es.getplayerlocation(self.userid)
        flist = []
        olist = []
        team = es.getplayerteam(self.userid)
        for id in es.getUseridList():
            if id != self.userid:
                x2,y2,z2 = es.getplayerlocation(id)
                if abs(x1-x2) < distance and abs(y1-y2) < distance and abs(z1-z2) < distance:
                    if team != es.getplayerteam(id):
                        olist.append(id)
                    else:
                        flist.append(id)
        return flist, olist
#End Player Class
#Begin Character Class
class Character(object):
    global Characters
    def __init__(self, userid=None):
        report('Character init start')
        self.userid = int(userid)
        self.steamid = playerlib.uniqueid(self.userid, True)
        if Players[self.userid]['character']:
            self.key = Characters[Players[self.userid]['character']]
            self.character = Players[self.userid]['character']
        else:
            self.key = None
            self.character = None
        report('Character init end')
    def Setup(self, Name, Forced=None):
        if Name not in Characters:
            if getPlayer(self.userid)['playerlib'].get('isdead') or int(es.getplayerteam(self.userid)) == 1:
                self.Create(Name)
            elif Forced:
                self.Create(Name)
            else:
                es.tell(self.userid, '#multi', text('Setup 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        elif Forced:
            self.Setup('%sX'%Name, 1)
        else:
            es.tell(self.userid, '#multi', text('Setup 2',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
    def Create(self, Name):
        Characters[Name] = {'creator':self.steamid,
                            'race':'Pending',
                            'classes':{},
                            'feats':['unspent'],
                            'abilities':{'Strength':None,
                                        'Constitution':None,
                                        'Dexterity':None,
                                        'Intelligence':None,
                                        'Wisdom':None,
                                        'Charisma':None},
                            'password':'locked',
                            'xp':0,
                            'level':1,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
        getPlayer(self.userid)['Player'].AddCharacter(Name)
        getPlayer(self.userid)['Menu'].ClassMenu()
        self.key = Characters[Name]
        self.character = Name
        es.tell(self.userid, '#multi', text('Create 1',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
    def SetPassword(self, Password):
        if Password != 'locked' and Password != 'demo' and Password != 'public':
            Characters[Players[self.userid]['character']]['password'] = Password
            es.tell(self.userid, '#multi', text('SetPassword 1',{'character':Players[self.userid]['character'],'password':Password},getPlayer(self.userid)['playerlib'].get('lang')))
    def GiveXp(self, amount, reason):
        if self.key['password'] != 'demo':
            if self.key['xp'] < Levels[20]:
                self.key['xp'] += amount
                if self.key['xp'] >= Levels[self.key['level']+1]:
                    if self.key['level'] == 10:
                        getPlayer(self.userid)['Character'].key['paragon path'] = 'pending'
                        getPlayer(self.userid)['Menu'].ParagonMenu()
                    else:
                        self.GiveLevel(1)
                    es.tell(self.userid, '#multi', text('GiveXp 1',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang')))
                else:
                    es.tell(self.userid, '#multi', text('GiveXp 2',{'amount':amount,'reason':reason},getPlayer(self.userid)['playerlib'].get('lang')))
            else:
                self.key['xp'] = Levels[20]
    def GiveLevel(self, amount, Class=None):
        if Class:
            self.key['classes'][Class]['level'] += amount
        else:
            if len(self.key['classes']) == 1:
                for c in self.key['classes']:
                    self.key['classes'][c]['level'] += 1
            else:
                for c in self.key['classes']:
                    if self.key['classes'][c]['level'] < 10:
                        self.key['classes'][c]['level'] += 1
                        break
        self.key['level'] += amount
        if self.key['level'] in Ability_Increases:
            getPlayer(self.userid)['Character'].key['stat increase'].append([1, text('GiveLevel 1',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang'))])
            getPlayer(self.userid)['Character'].key['stat increase'].append([1, text('GiveLevel 1',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang'))])
        if self.key['level'] in [11, 21]:
            for a in Ability_List:
                self.key['abilities'][a] += 1
            es.tell(self.userid, '#multi', text('GiveLevel 2',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang')))
        if self.key['level'] in Feat_Increases:
            self.key['feats'].append('unspent')
#End Classes
#Begin handels for our 'dnd' command that can be run in client console/chat
def Command():
    userid = int(es.getcmduserid())
    steamid = playerlib.uniqueid(userid, True)
    player = getPlayer(userid)['playerlib']
    arg1 = es.getargv(1).lower()
    argcount = es.getargc()
    stringcount = 2
    commandstring = ''
    while stringcount < argcount:
        addstring = es.getargv(stringcount)
        if commandstring:
            commandstring = '%s %s'%(commandstring, addstring)
        else:
            commandstring = addstring
        stringcount += 1
    if arg1 == 'create':
        getPlayer(userid)['Character'].Setup(commandstring)
    elif arg1 == 'load':
        if player.get('isdead') or int(es.getplayerteam(userid)) == 1:
            if commandstring in Characters:
                if Characters[commandstring]['password'] == 'locked' and Characters[commandstring]['creator'] == steamid:
                    getPlayer(userid)['Player'].SetCharacter(commandstring)
                elif Characters[commandstring]['password'] == 'public':
                    getPlayer(userid)['Player'].SetCharacter(commandstring)
                else:
                    getPlayer(userid)['Player'].TempCharacter(commandstring)
            else:
                es.tell(userid, '#multi', text('Command 1',{'commandstring':commandstring},getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', text('Command 2',{},player.get('lang')))
    elif arg1 == 'passwordenter':
        getPlayer(userid)['Player'].PasswordEnter(commandstring)
    elif arg1 == 'passwordset':
        getPlayer(userid)['Character'].SetPassword(commandstring)
    elif arg1 == 'loadmenu':
        getPlayer(userid)['Player'].CharacterMenu()
    elif arg1 == 'menu' or arg1 == 'mainmenu':
        getPlayer(userid)['Menu'].MainMenu()
    elif arg1 == 'stats':
        getPlayer(userid)['Menu'].CharacterInformation()
    elif arg1 == 'help' or arg1 == '':
        getPlayer(userid)['Menu'].HelpMenu()
    elif arg1 == 'info':
        getPlayer(userid)['Menu'].InfoMenu()
    elif arg1 == 'public':
        getPlayer(userid)['Menu'].MainMenuSelect(choice=5)
    else:
        es.tell(userid, '#multi', text('Command 3',{'commandstring':commandstring},getPlayer(userid)['playerlib'].get('lang')))
#End Character Class
#End our command handels
#Our Client Filter
def _cc_filter(userid, args):
    if not es.isbot(userid):
        if args[0].lower() == 'jointeam':
            if not len(getPlayer(userid)['Character'].key['classes']):
                getPlayer(userid)['Menu'].ClassMenu()
                es.tell(userid, '#multi', text('player_spawn 1',{},getPlayer(userid)['playerlib'].get('lang')))
                return False
            elif not statCheck(userid):
                getPlayer(userid)['Menu'].StatManual()
                es.tell(userid, '#multi', text('player_spawn 2',{},getPlayer(userid)['playerlib'].get('lang')))
                return False
            elif getPlayer(userid)['Character'].key['race'] == 'Pending':
                getPlayer(userid)['Menu'].RaceMenu()
                es.tell(userid, '#multi', text('player_spawn 3',{},getPlayer(userid)['playerlib'].get('lang')))
                return False
    return True
es.addons.registerClientCommandFilter(_cc_filter)